diff --git a/corefreq-api.h b/corefreq-api.h
index f726dce..259fad1 100644
--- a/corefreq-api.h
+++ b/corefreq-api.h
@@ -519,7 +519,7 @@ typedef struct {
 		IDLEDRIVER	IdleDriver;
 
 		int		taskCount;
-		TASK_MCB	taskList[PID_MAX_DEFAULT];
+		TASK_MCB	taskList[TASK_LIMIT];
 
 		MEM_MCB		memInfo;
 
diff --git a/corefreq.h b/corefreq.h
index bc45e38..4205ab6 100644
--- a/corefreq.h
+++ b/corefreq.h
@@ -257,7 +257,7 @@ typedef struct
 		enum SORTBYFIELD sortByField;
 		int		reverseOrder,
 				taskCount;
-		TASK_MCB	taskList[PID_MAX_DEFAULT];
+		TASK_MCB	taskList[TASK_LIMIT];
 
 		MEM_MCB		memInfo;
 
diff --git a/corefreqd.c b/corefreqd.c
index 1280df4..50e91ec 100644
--- a/corefreqd.c
+++ b/corefreqd.c
@@ -3366,10 +3366,11 @@ int Shm_Manager(FD *fd, PROC *Proc)
 			Shm->Proc.CPU.OnLine,
 			Shm->Proc.CPU.Count );
 		if (Quiet & 0x100)
-		 printf("  SleepInterval(%u), SysGate(%u)\n\n",
+		 printf("  SleepInterval(%u), SysGate(%u), %ld tasks\n\n",
 			Shm->Sleep.Interval,
 			!BITVAL(Shm->SysGate.Operation, 0) ?
-				0:Shm->Sleep.Interval * Shm->SysGate.tickReset);
+				0:Shm->Sleep.Interval * Shm->SysGate.tickReset,
+			TASK_LIMIT);
 		if (Quiet)
 			fflush(stdout);
 
diff --git a/corefreqk.c b/corefreqk.c
index b845018..f7f63c7 100644
--- a/corefreqk.c
+++ b/corefreqk.c
@@ -3615,7 +3615,8 @@ void Sys_DumpTask(SYSGATE *SysGate)
 		memcpy(SysGate->taskList[cnt].comm, thread->comm,TASK_COMM_LEN);
 
 		task_unlock(thread);
-		cnt++;
+		if (cnt < TASK_LIMIT)
+			cnt++;
 	}
 	rcu_read_unlock();
 	SysGate->taskCount = cnt;
diff --git a/coretypes.h b/coretypes.h
index ca7f7cb..569bd2f 100644
--- a/coretypes.h
+++ b/coretypes.h
@@ -4,7 +4,7 @@
  * Licenses: GPL2
  */
 
-#define COREFREQ_VERSION	"1.24.2"
+#define COREFREQ_VERSION	"1.24.3"
 
 enum {	GenuineIntel,		\
 	Core_Yonah,		\
@@ -1171,10 +1171,6 @@ typedef struct {
 #define TASK_COMM_LEN		16
 #endif
 
-#ifndef PID_MAX_DEFAULT
-#define PID_MAX_DEFAULT		(1<<15)
-#endif
-
 enum SORTBYFIELD {F_STATE, F_RTIME, F_UTIME, F_STIME, F_PID, F_COMM};
 #define SORTBYCOUNT	(1 + F_COMM)
 
@@ -1199,6 +1195,15 @@ typedef struct {
 				freehigh;
 } MEM_MCB;
 
+#define SYSGATE_STRUCT_SIZE	( sizeof(IDLEDRIVER)			\
+				+ sizeof(int)				\
+				+ sizeof(MEM_MCB)			\
+				+ sizeof(unsigned int)			\
+				+ 4 * MAX_UTS_LEN )
+
+#define TASK_LIMIT		(((4096 << 5) - SYSGATE_STRUCT_SIZE)	\
+				/ sizeof(TASK_MCB))
+
 // Input-Output Control
 #define COREFREQ_TOGGLE_OFF	0x0000000000000000L
 #define COREFREQ_TOGGLE_ON	0x0000000000000001L
